/* gqlist.c 
 * Steven Rostedt.
 *
 * I'm showing this everywhere!
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include <stdio.h>
#include <glib.h>
#include "gqlist.h"

gint 
comparedata (gchar *a, gchar *b)
{
  /*
   * Return the inverse of strcmp
   */
  return strcmp(a,b) * -1;
}

gchar *
datalist[] = {
  "data 1",
  "data 2",
  "data 3",
  "data 4",
  "data 5",
  "data 6",
  "data 7",
  "data 8",
  "data 9",
  "data 10",
  NULL
};

int
main () 
{
  GQList *gqlist;
  gchar *data;
  gint i;

  printf ("g_qlist_new(NULL)\n");

  gqlist = g_qlist_new(NULL);

  for (i = 0; datalist[i]; i++) 
    g_qlist_append(gqlist,datalist[i]);

  printf ("data appended:\n");

  for (i = 0; (data = g_qlist_get_data(gqlist,i)) != NULL; i++)
    printf ("\t%s\n",data);
  
  for (i = 0; (data = g_qlist_remove_first(gqlist)) != NULL; i++)
    printf ("\tremove first %s\n",data);
  
  printf ("qlist contains:\n");

  for (i = 0; (data = g_qlist_get_data(gqlist,i)) != NULL; i++)
    printf ("\t%s\n",data);

  
  for (i = 0; datalist[i]; i++) 
    g_qlist_append(gqlist,datalist[i]);

  printf ("data appended:\n");

  for (i = 0; (data = g_qlist_get_data(gqlist,i)) != NULL; i++)
    printf ("\t%s\n",data);
  
  for (i = 0; (data = g_qlist_remove_last(gqlist)) != NULL; i++)
    printf ("\tremove last %s\n",data);
  
  printf ("qlist contains:\n");

  for (i = 0; (data = g_qlist_get_data(gqlist,i)) != NULL; i++)
    printf ("\t%s\n",data);
  
  for (i = 0; datalist[i]; i++) 
    g_qlist_append(gqlist,datalist[i]);

  printf ("data appended:\n");

  for (i = 0; (data = g_qlist_get_data(gqlist,i)) != NULL; i++)
    printf ("\t%s\n",data);
  
  for (i = 0; (data = g_qlist_remove_index(gqlist,i)) != NULL; i++)
    printf ("\tremove index %s %d\n",data,i);
  
  printf ("qlist contains:\n");

  for (i = 0; (data = g_qlist_get_data(gqlist,i)) != NULL; i++)
    printf ("\t%s\n",data);

  printf ("qlist backward sort:\n");

  g_qlist_sort (gqlist,(GCompareFunc)comparedata);

  for (i = 0; (data = g_qlist_get_data(gqlist,i)) != NULL; i++)
    printf ("\t%s\n",data);



  return 0;
}

